/*================================================
	nicoplayer.js
================================================*/

// NX̍쐬,`
var npsuper = Class.create();
npsuper.prototype =
{
	// Cuo[W
	lib_version : "1.12",

	// fobO[h
	// true : NicoPlayerɓnꂽR}heEBhEɕ\
	debug : false, 


	// [initialize]
	initialize : function(){},

	//------------------------------------------------
	// NicoPlayerĂяo郁\bh
	//------------------------------------------------

	// [onChangeMediaState] fBA̍ĐԂύXꂽɌĂяo
	//  state : Đ ( "Stopped", "Paused", "Running", "" )
	onChangeMediaState : function( state )
	{
	},

	// [onChangePlayList] vCXgύXꂽƂɌĂяo
	onChangePlayList : function()
	{
	},

	// [onNotifyPostComment] Rg̓eƂɌĂяo
	//  result : Rg̓eʂ\^l
	onNotifyPostComment : function( result )
	{
	},

	// [onNotify] NicoPlayerʒmbZ[WꂽƂɌĂяo(Ŏgp)
	//  message : ʒmbZ[W
	onNotify : function( message )
	{
		switch( message )
		{
			case "postComment:result:true":
				this.onNotifyPostComment( true );
				break;
			case "postComment:result:false":
				this.onNotifyPostComment( false );
				break;
			default:
				break;
		}
	},

	//------------------------------------------------
	// NicoPlayerɏ郁\bh
	//------------------------------------------------

	// [execApp] t@Cs
	//  file : st@CpX
	//      arg  : t@Cɓn
	// WinAPIShellExecute()gpt@Cs܂
	// file""Ŋ܂
	// argɃpXnꍇ̓AvP[Vɂ""ŊKv܂
	execApp : function( file, arg )
	{
		file = this.encloseString( file );
		this.execCmd( "exec " + file + " " + arg );
	},

	// [addMessage] EBhEɃbZ[Wǉ
	//  msg : bZ[W
	// msg""Ŋ܂
	addMessage : function( msg )
	{
		msg = this.encloseString( msg );
		this.execCmd( "info msg=" + msg );
	},

	// [execCmd] NicoPlayerɃR}h
	//  cmd : R}h
	// R}h͋NIvVŎwłeƓł
	// NicoPlayer𑀍삷SẴ\bhĂяo܂
	execCmd : function( cmd )
	{
		var url = "nicoplayer:" + cmd;
		if( cmd.match( "^get .*" ) )
		{
			url += " hwnd=VIDEOINFO";
		}
		url += " -inactive";
		if( this.debug )
		{
			url += " -echo";
		}
		window.navigate( url );
	},

	// [postComment] Rg𓊍e
	// 	comment : Rg
	//	command : R}h
	//	vpos    : ̈ʒu(1/100b)
	//	id      : ID(ȗƌݍĐ̓悪w肳܂)
	postComment : function( comment, command, vpos, id )
	{
		// _uNH[e[VƉsGXP[v
		comment.replace( /"/g, '\\"' );
		comment.replace( /\n/g, '\\n' );

		comment = this.encloseString( comment );
		command = this.encloseString( command );

		if( id == undefined )
		{
			id = "";
		}

		this.execCmd( "player -postcomment comment=" + comment + " command=" + command + " vpos=" + vpos + " id=" + id );
	},

	// 폜̃\bhł
	// [readFile] [J̃eLXgt@Cǂݍ
	//  path : t@CpX
	// ߂l    : eLXgf[^
	readFile : function( path )
	{
		path = this.encloseString( path );
		this.execCmd( "get -file path=" + path );
		return $('exchange').innerHTML.replace( /^<PRE>((.|\n)*)<\/PRE>$/, "$1" );	// K\Ɨǂ@Ȃ..!?
	},

	// 폜̃\bhł
	// [writeFile] [J̃eLXgt@Cɏ
	//  path : t@CpX
	//      data : ރeLXgf[^
	writeFile : function( path, data )
	{
		path = this.encloseString( path );
		$('exchange').innerHTML = "<PRE>" + data + "</PRE>";
		this.execCmd( "other -writefile path=" + path );
	},

	//------------------------------------------------
	// NicoPlayer擾郁\bh
	//------------------------------------------------

	// [getVersion] NicoPlayer̃o[W擾
	// ߂l : o[Wio[ "x.xx"
	getVersion : function()
	{
		this.execCmd( "get -version" );
		return $('exchange').innerText;
	},

	// [getSoftDir] NicoPlayertH_pX擾
	// ߂l : t@CpX
	getSoftDir : function()
	{
		this.execCmd( "get -softdir" );
		return $('exchange').innerText;
	},

	// [getPlayFile] ĐJnɎw肵t@C擾
	// ߂l : t@CpX
	getPlayFile : function()
	{
		this.execCmd( "get -playfile" );
		return $('exchange').innerText;
	},

	// [getMediaFile] Đ̃fBAt@C擾
	// ߂l : t@CpX
	getMediaFile : function()
	{
		this.execCmd( "get -mediafile" );
		return $('exchange').innerText;
	},

	// [getCommentFile] Đ̃Rgt@C擾
	// ߂l : t@CpX
	getCommentFile : function()
	{
		this.execCmd( "get -commentfile" );
		return $('exchange').innerText;
	},

	// [getInfoFile] Đ̃fBAt@CɑΉ铮t@C擾
	// ߂l : t@CpX
	getInfoFile : function()
	{
		this.execCmd( "get -infofile" );
		return $('exchange').innerText;
	},

	// [getTime] ݂̍ĐԂ擾
	// ߂l : Đ(ms)
	getTime : function()
	{
		this.execCmd( "get -time" );
		return $('exchange').innerText;
	},

	// [getLength] fBA̒擾
	// ߂l : fBA̒(ms)
	getLength : function()
	{
		this.execCmd( "get -length" );
		return $('exchange').innerText;
	},

	// [getMediaState] fBA̍ĐԂ擾
	// ߂l : Đ ( "Stopped", "Paused", "Running", "" )
	// 󕶎̏ꍇ̓t@CĐĂȂƂ\܂
	getMediaState : function()
	{
		this.execCmd( "get -mediastate" );
		return $('exchange').innerText;
	},

	// [getPlayList] vCXg̃f[^擾
	// ߂l : vCXgf[^̃IuWFNgz
	// vpeB name : t@C
	//            path : t@CpX
	getPlayList : function()
	{
		this.execCmd( "get -playlist" );
		return eval( "(" + $('exchange').innerText + ")" );
	},

	// [getNavigateMode] y[Wړ̓擾
	// ߂l : y[Wړ̓( "Inside" : EBhEŊJ ,  "Outside" : OuEUŊJ )
	getNavigateMode : function()
	{
		this.execCmd( "get -navigatemode" );
		return $('exchange').innerText;
	},

	//------------------------------------------------
	// NicoPlayeȑݒ肷郁\bh
	//------------------------------------------------

	// [setNavigateMode] y[Wړ̓ݒ
	//  mode : y[Wړ̓( "Inside" : EBhEŊJ ,  "Outside" : OuEUŊJ )
	setNavigateMode : function( mode )
	{
		this.execCmd( "videoinfo -navigatemode mode=" + this.encloseString( mode ) );
	},

	//------------------------------------------------
	// ėp
	//------------------------------------------------

	// [getThumbnailSource] TlC̃\[X擾
	//  idMovie       : ID
	//      pathThumbnail : TlCpX
	// ߂l : TlC\[X
	getThumbnailSource : function( idMovie, pathThumbnail )
	{
		var urlThumbnail = "http://tn-skr.smilevideo.jp/smile?i=" + idMovie;
		var srcThumbnail;
		if( pathThumbnail )
		{
			srcThumbnail = pathThumbnail;
		}
		else
		{
			srcThumbnail = urlThumbnail;
		}
		return srcThumbnail;
	},

	// [drawThumbnail] TlC\
	//  srcThumbnail : TlC\[X
	drawThumbnail : function( srcThumbnail )
	{
		document.write( '<img src="' + srcThumbnail + '" align="left" width="130" height="100" alt="TlC">' );
	},

	// [encloseString] ""Ŋ
	//  str : ΏۂƂȂ镶
	// ߂l : ""Ŋꂽ
	// ""ŊĂꍇ͈̂܂ܕԂ܂
	encloseString : function( str )
	{
		if( str.match('^".*"$') == null )
		{
			str = '"' + str + '"';
		}
		return str;
	},

	dummyLastFunc: function(){}	// [dummyLastFunc]
};// NX`

var npbase = Class.create();
npbase.prototype = Object.extend( new npsuper, {} );

// NX̃CX^X쐬
var np = new npbase();

